Ruby - Bug #7822

Dir.mkdir can't handle long Windows Unicode paths (\2\UNC\)
02/10/2013 01:36 PM - shyxormz (Patrick Pokatilo)

Status: Rejected
Priority: Normal
Assignee: usa (Usaku NAKAMURA)

Target version:

ruby -v: ruby 1.9.3p362 (2012-12-25) Backport:
[(386-mingw32]

Description

Code:
Dir.mkdir "//?/C:/" + "test" * 100

What | expected:

Ruby will create directory
/1?/C:/testtesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttes
ttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttestt
esttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttest, judging from
http://msdn.microsoft.com/en-us/library/aa365247.aspx

What happened on the second call:

Errno::ENOENT: No such file or directory -
/1?/C:/testtesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttestiesttesttesttesttesttesttesttesttesttes
ttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttestiesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttestt
esttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttest

from (irb):6:in “mkdir'

Related issues:
Related to Ruby - Bug #7821: FileUtils.mkdir_p fails on Windows Unicode paths... Rejected 02/10/2013

History

#1 - 02/13/2013 06:28 PM - usa (Usaku NAKAMURA)

- Subject changed from Dir.mkdir can't handle long Windows Unicode paths (\2\UNC)\) to Dir.mkdir can&#x27;t handle long Windows Unicode paths
(W?2\UNC))

- Status changed from Open to Assigned
- Assignee set to usa (Usaku NAKAMURA)

#2 - 04/16/2014 03:36 AM - elovelan (Eric Loveland)

The linked article mentions that each component (individual folder in the path) can have a maximum of 255 characters.
The following works:

Dir.mkdir "N\\\\?2\\C:\\#{'t'*255}"
Dir.mkdir "N\\ANZ2ANC:A\\#{'t"'*255}\\#{'t'*255}"

However, there is a general Ruby file issue related to this: Windows does not allow forward slashes for Win32 File Namespaces (\?\ paths). Thus
these paths cannot be used with any methods that use File::SEPARATOR, such as File.join since File::SEPARATOR is /' on Windows.

#3 - 04/16/2014 04:23 AM - usa (Usaku NAKAMURA)

(1) Windows has the limitation about the length of each directory name.
It's 255 characters.
So, even if with using UNC name, you cannot make such directory, Patrick.

(2) Yes, you are right, Eric.

Only when using "\?\", Windows does not recognize "/" as the separator
(the document which Patrick mentioned says so.)

So, use "\" as the separator when using "\?\" for the time being.

#4 - 04/16/2014 11:19 AM - elovelan (Eric Loveland)

| would recommend that this bug be closed. However, | have not found any feature requests for better support of "\?\". Is it worth submitting one or

06/13/2025 12



http://msdn.microsoft.com/en-us/library/aa365247.aspx

would this be better handled with a gem?

#5 - 04/16/2014 12:19 PM - usa (Usaku NAKAMURA)
- Related to Bug #7821: FileUtils.mkdir_p fails on Windows Unicode paths (\\2\UNC)) if dir already exists added

#6 - 04/16/2014 12:24 PM - usa (Usaku NAKAMURA)

- Status changed from Assigned to Rejected

After all, the user using special form like "\?" should know the meaning and effect,
so ruby doesn't ought to support it.
Of course, if there is a good patch, | my accept it.
